#!/bin/bash

YDIR=`pwd`
args=$# 

if [ $args == 0  ]
then
   echo "did not specify jython file!"
   echo "run jHepWork file in batch mode without the editor"
   echo "TYPE: a_run.sh <file>.py"
   exit 1;
fi

 
# set here home directory where the jehep.jar file is located 
JEHEP_HOME="../../../jehep"

FILE=$1

################## do not edit ###############################
JAVA_HEAP_SIZE=256


CLASSPATH="."


 # Add in your .jar files first
for i in ${JEHEP_HOME}/lib/*/*.jar
do
      CLASSPATH=$CLASSPATH:"$i"
done


# convert the unix path to windows
if [ "$OSTYPE" = "cygwin32" ] || [ "$OSTYPE" = "cygwin" ] ; then
   CLASSPATH=`cygpath --path --windows "$CLASSPATH"`
fi


JYTHON_HOME=${JEHEP_HOME}"/lib/jython"
EXT_DIR=${JEHEP_HOME}/lib/freehep:${JEHEP_HOME}/lib/system:${JEHEP_HOME}/lib/user:${JEHEP_HOME}/lib/update


CP=${JYTHON_HOME}"/jython.jar"
if [ ! -z "$CLASSPATH" ]
then
  CP=$CP:$CLASSPATH
fi


# run file
java  -mx${JAVA_HEAP_SIZE}m  -classpath "$CP" -Dpython.home=${JYTHON_HOME} \
                    -Djava.ext.dirs=${EXT_DIR}  \
                     org.python.util.jython $FILE



